<?php
/**
 * Created by JetBrains PhpStorm.
 * User: gustavoavila
 * Date: 22/11/12
 * Time: 11:42
 * To change this template use File | Settings | File Templates.
 */

namespace Facilities\Util;

class Util
{
    public static function copyAndReplace($resultSet, $replacements)
    {
        try{
            if(!empty($resultSet)) {
                // Replace callback function.
                $callback = function($el) use ($replacements){
                    foreach($replacements as $replace => $newValue) {
                        if(!isset($replace)) throw new \Exception("Invalid replacement \{{$replace}\}");
                        // If replacemente content is a function execute and get it's return value.
                        $el[$replace] = is_callable($newValue) ? $newValue() : $newValue;
                    }
                    return $el;
                };
                return array_map($callback, $resultSet);
            } else {
                return null;
            }
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public static function parseHtmlRgbToHex($rgbString)
    {
        $matches = array();
        $regex = "/rgb\((\d{1,3}),\s?(\d{1,3}),\s?(\d{1,3})\)/";
        preg_match($regex, $rgbString, $matches);
        list($rgbString, $r, $g, $b) = $matches;
        return self::rgbToHex($r, $g, $b);
    }

    public static function rgbToHex($r, $g, $b)
    {
     $r=dechex($r);
     if (strlen($r)<2) $r='0'.$r;

     $g=dechex($g);
     if (strlen($g)<2)$g='0'.$g;

     $b=dechex($b);
     if (strlen($b)<2) $b='0'.$b;

     return '#' . $r . $g . $b;
    }

    public static function splitArrayStringInArrays($text_key, $array, $offset)
    {
        $text = $array[$text_key];
        $iterations = ceil((float)strlen($text) / $offset);
        $new_array = array();
        for($i = 0; $i < $iterations; $i++) {
            $start = $offset * $i;
            $substr = substr($text, $start, $offset);
            $new_array[$i] = $array;
            $new_array[$i][$text_key] = $substr;
        }

        return $new_array;
    }

    public static function updateAudit(array $custom_fields = null){
        if (isset($custom_fields) === true) {
            foreach ($custom_fields as $field => $default_value) {
                tk_set_field_value($field, $default_value);
            }
        } else {
            tk_set_field_value('DTULTATU', now());
            tk_set_field_value('NRORGULTATU', Ambiente::getNrorg());
            tk_set_field_value('CDOPERULTATU', Ambiente::getCdOperador());
        }
    }


    public static function updateEntityAudit(&$obj_entity){
        try{
            $obj_entity->setDtultatu(now());
            $obj_entity->setNrorgultatu(Ambiente::getNrorg());
            $obj_entity->setCdoperultatu(Ambiente::getCdOperador());
        } catch (TkException $e) {
            throw $e;
        }
    }

    public static function newAudit($tab_name = null){
        tk_set_field_value('NRORG',Ambiente::getNrorg(),$tab_name);
        tk_set_field_value('IDATIVO','S', $tab_name);
        tk_set_field_value('DTINCLUSAO',now(), $tab_name);
        tk_set_field_value('NRORGINCLUSAO',Ambiente::getNrorg(), $tab_name);
        tk_set_field_value('CDOPERINCLUSAO',Ambiente::getCdOperador(), $tab_name);
    }

    public static function newEntityAudit(&$obj_entity){
        try{
            $obj_entity->setDtinclusao(now());
            $obj_entity->setNrorginclusao(Ambiente::getNrorg());
            $obj_entity->setCdoperinclusao(Ambiente::getCdOperador());
            $obj_entity->setDtultatu(null);
            $obj_entity->setNrorgultatu(null);
            $obj_entity->setCdoperultatu(null);
        } catch (TkException $e) {
            throw $e;
        }
    }

    /**
     * Enter description here ...
     *
     * @param string|array $fields 	  Campos as serem Habilitados.
     * @param string|array $ref_field Campos referencia.
     *
     * @return void|boolean
     */
    public static function toggleNullFieldsByRef($fields, $ref_field, $tab_name = null, $window_name = null){
        if (is_array($fields) === false) {
            $fields = array($fields);
        }

        $value = tk_get_field_value_from_window($window_name, $ref_field, $tab_name, null);

        foreach ($fields as $field) {
            if (empty($value) === true || isset($value) === false) {
                tk_enable_field($field, $tab_name, $window_name);
            } else {
                tk_disable_field($field, $tab_name, $window_name);
            }
        }
    }

    /**
     * Enter description here ...
     *
     * @param string $field_name Field name.
     *
     * @return string
     */
    public static function getFieldMask($field_name){
        $field = tk_get_field($field_name);
        $mask = $field->fieldRow['MASK'];
        return $mask;
    }

    public static function removeMascaraInscricao($string)
    {
        $patterns[] = "/\//";
        $patterns[] = "/\-/";
        $patterns[] = "/\./";
        $patterns[] = "/\(/";
        $patterns[] = "/\)/";
        $patterns[] = "/\,/";

        return preg_replace($patterns,"","/".$string."/");
    }

    /**
     * Enter description here ...
     *
     * @param string $masked_value Valor com mascara.
     * @param string $regex        Expressão regular.
     *
     * @return mixed|NULL
     */
    public static function removeMask($masked_value, $regex){
        $mask = $masked_value;
        if (isset($mask) === true) {
            $value = preg_replace($regex, '', $mask);
            return $value;
        } else {
            return null;
        }
    }

    public static function removeCurrencyMask($value)
    {
        return str_replace(',', '.', str_replace('.', '', $value));
    }

    public static function toDatabaseFloat($val)
    {
        return str_replace('.', ',', $val);
    }

    public static function toCurrencyFormat($val)
    {
        return number_format(str_replace(',','.',$val),2,',','.');
    }

    public static function delAcentos($frase) {

        $pasta = strtolower( str_replace("[^a-zA-Z0-9-]", "", strtr(utf8_decode(trim($frase)), utf8_decode("áàãâéêíóôõúüñçÁÀÃÂÉÊÍÓÔÕÚÜÑÇ "),"aaaaeeiooouuncAAAAEEIOOOUUNC")) );

        return utf8_encode(substr($pasta, 0, 14));
    }

    public static function diffDays($start, $end)
    {
        $start = self::dataToTimestamp($start);
        $end = self::dataToTimestamp($end);
        $diff = ($end - $start);
        $dias = round(($diff/60/60/24));
        return $dias;
    }

    public static function diffMonths($start, $end)
    {
        list($dia1) = explode("/", $start);
        $start = self::dataToTimestamp($start);
        list($dia2) = explode("/", $end);
        $end = self::dataToTimestamp($end);
        $diff = ($end - $start);
        $diff = floor(($diff)/2628000);
        if ($dia1 < $dia2) $diff +=  1;
        return $diff;
    }

    private static function dataToTimestamp($data) {
       list($dia, $mes, $ano) = explode("/", $data);
       return mktime(0, 0, 0, $mes, $dia, $ano);
    }

    public static function createValidationArray($array, $col)
    {
        $return = array();
        foreach ($array as $data) {
            if ($data[$col] !== null && $data[$col] !== '')
                $return[] = $data[$col];
        }

        return array_unique($return);
    }

    public static function createIndexedArray($data, $index, $val_index)
    {
        $array = array();
        foreach($data as $row){
            $array[$row[$index]][] = $row[$val_index];
        }

        return $array;
    }

    public static function trunc($number)
    {
        $number  = explode('.',$number);
        return (int)$number[0];
    }

    public static function formatReal($value)
    {
        return 'R$ '.number_format($value,2,',','.');
    }

    /**
     * @static
     * @param mixed $needle <p>
     * The searched value.
     * </p>
     * <p>
     * If needle is a string, the comparison is done
     * in a case-sensitive manner.
     * </p>
     * @param array $haystack <p>
     * The array.
     * </p>
     * @param bool $strict [optional] <p>
     * If the third parameter strict is set to true
     * then the array_search function will also check the
     * types of the
     * needle in the haystack.
     * </p>
     * @param array $path Used to iterate function recursevely.
     * @return Array(0=>Key of first match of needle, => 1 => Searched value)
     */
    public static function array_search_recursive( $needle, $haystack, $strict=false, $path=array() )
    {
        if( !is_array($haystack) ) {
            return false;
        }

        foreach( $haystack as $key => $val ) {
            if( is_array($val) && $subPath = self::array_search_recursive($needle, $val, $strict, $path) ) {
                $path = array_merge($path, array($key), $subPath);
                return $path;
            } elseif( (!$strict && $val == $needle) || ($strict && $val === $needle) ) {
                $path[] = $key;
                return $path;
            }
        }
        return false;
    }

    public static function addDays($data, $qtdias)
    {
        $dateObj = new Zend_Date($data, null, 'pt_BR');
        if(isset($qtdias)) $dateObj->addDay($qtdias);
        return $dateObj->toString('dd/MM/Y');
    }
}
