IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE 
	        O.NAME = 'ATUALIZA_CUSTO_COMPRA'  AND
	        TYPE = 'P' 			       AND
	        U.UID = O.UID             AND
	        U.NAME = USER)

DROP PROCEDURE ATUALIZA_CUSTO_COMPRA
GO
                                    
CREATE PROCEDURE ATUALIZA_CUSTO_COMPRA @P_FILIAL       VARCHAR(04),
                                       @P_PRODINI      VARCHAR(20),
                                       @P_PRODFIM      VARCHAR(20),
                                       @P_CDALMOXARIFE VARCHAR(06),
                                       @P_CDLOCALESTOQ VARCHAR(06),
                                       @P_TALMOX       VARCHAR(1),
                                       @P_TLOCAL       VARCHAR(1),
                                       @P_DTINICIAL    DATETIME,
                                       @P_DTFINAL      DATETIME
AS
   DECLARE @V_MSG1         VARCHAR(120);
   DECLARE @V_MSG2         VARCHAR(120);
   DECLARE @V_DATA         DATETIME;
   DECLARE @V_FATOCONV     DOUBLE PRECISION;
   DECLARE @V_VRULTCMPLIQ  DOUBLE PRECISION;
   DECLARE @V_VRULTCMPBRU  DOUBLE PRECISION;
   DECLARE @V_VRULTCMPLM1  DOUBLE PRECISION;
   DECLARE @V_VRULTCMPLM2  DOUBLE PRECISION;
   DECLARE @V_VRULTCMPBM1  DOUBLE PRECISION;
   DECLARE @V_VRULTCMPBM2  DOUBLE PRECISION;
   DECLARE @V_VRCUSTLCMPM1 DOUBLE PRECISION;
   DECLARE @V_VRCUSTLCMPM2 DOUBLE PRECISION;
   DECLARE @V_VRSEGULCMPM1 DOUBLE PRECISION;
   DECLARE @V_VRSEGULCMPM2 DOUBLE PRECISION;
   DECLARE @V_VRINDICE1    DOUBLE PRECISION;
   DECLARE @V_VRINDICE2    DOUBLE PRECISION;
   DECLARE @V_DTLANCMOVI   DATETIME;
   DECLARE @V_NRSEQUITEM   VARCHAR(4);
   DECLARE @V_CDPRODUTO    VARCHAR(10);
   DECLARE @V_CDPRODMOVI   VARCHAR(10);
   DECLARE @V_VRLANCTOEST  DOUBLE PRECISION;
   DECLARE @V_VRLANCTOBRUT DOUBLE PRECISION;
   DECLARE @V_VRFATOCONV   DOUBLE PRECISION;
   DECLARE @V_NRLANCTONF   VARCHAR(10);
   DECLARE @V_QTTOTLANCTO  DOUBLE PRECISION;
   DECLARE @V_VRTOTLANCTO  DOUBLE PRECISION;
   DECLARE @V_VRUNILANCTO  DOUBLE PRECISION;
   DECLARE @V_CDFILIMOVI   VARCHAR(4);
   DECLARE @V_IDTPLANCTO   VARCHAR(1);
   DECLARE @V_CDALMOXARIFE VARCHAR(6);
   DECLARE @V_CDLOCALESTOQ VARCHAR(6);
   DECLARE @V_NRLOTEESTQ   VARCHAR(20);
   DECLARE @V_NRSUBLOTE    VARCHAR(4);
   DECLARE @V_NRLANCESTQ   VARCHAR(10);
   DECLARE @V_NRLANCESTQ2   VARCHAR(10);
   DECLARE @V_CDFILIAL     VARCHAR(4);
   DECLARE @V_VRCUSTLOGLAN DOUBLE PRECISION;
   DECLARE @V_VRSEGULOGLAN DOUBLE PRECISION;
   DECLARE @V_IDPERVALOR   VARCHAR(01);
   DECLARE @V_IDPERVALOR2  VARCHAR(01);
   DECLARE @V_CDINDICEMF   VARCHAR(04);
   DECLARE @V_CDINDICEMF2  VARCHAR(04);
   DECLARE @V_CDTPINDICE   VARCHAR(01);
   DECLARE @V_CDTPINDICE2  VARCHAR(01);

BEGIN

   SELECT @V_CDTPINDICE  = MAX(ISNULL(CDTPINDICE,'1')),
          @V_IDPERVALOR  = MAX(ISNULL(IDPERVALOR,'2')),
          @V_CDINDICEMF  = MAX(CDINDICEMF),
          @V_CDTPINDICE2 = MAX(ISNULL(CDTPINDICE2,'1')),
          @V_IDPERVALOR2 = MAX(ISNULL(IDPERVALOR2,'2')),
          @V_CDINDICEMF2 = MAX(CDINDICEMF2)
     FROM PARAMGERAL;


   DECLARE C_PRODUTO CURSOR FOR

   SELECT DISTINCT PF.CDPRODUTO
     FROM PRODUTO P, PRODFILI PF
    WHERE P.CDARVPROD BETWEEN @P_PRODINI AND @P_PRODFIM
      AND CDFILIAL = @P_FILIAL
      AND ISNULL(PF.IDCNTRESTOQ,'S') = 'S'
      AND ISNULL(P.IDPRODATIVPR,'S') = 'S'
      AND P.CDPRODESTO = PF.CDPRODUTO;

    OPEN C_PRODUTO;
    FETCH NEXT FROM C_PRODUTO INTO @V_CDPRODUTO;
    WHILE (@@FETCH_STATUS = 0) BEGIN
       DELETE FROM CUSTOCMPPROD
        WHERE CDFILIAL     = @P_FILIAL
          AND ((CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_TALMOX = 'T'))
          AND ((CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_TLOCAL = 'T'))
          AND CDPRODUTO    = @V_CDPRODUTO
          AND DTCUSTCMPPRO BETWEEN @P_DTINICIAL AND @P_DTFINAL;

       SET @V_DATA = @P_DTINICIAL;
       WHILE(@V_DATA<=@P_DTFINAL) BEGIN
          DECLARE C_INSERE CURSOR FOR

          SELECT MAX(NRLANCESTQ) NRLANCESTQ, NRLOTEESTQ, NRSUBLOTE, MAX(NRSEQUITEM) NRSEQUITEM,
                 CDALMOXARIFE, CDLOCALESTOQ
            FROM ITLANCTOEST I
           WHERE CDFILIMOVI   = @P_FILIAL   
             AND ((CDALMOXARIFE = @P_CDALMOXARIFE) OR (@P_TALMOX = 'T'))
             AND ((CDLOCALESTOQ = @P_CDLOCALESTOQ) OR (@P_TLOCAL = 'T'))
             AND CDPRODMOVI    = @V_CDPRODUTO
             AND DTLANCMOVI   = @V_DATA
          GROUP BY NRLOTEESTQ, NRSUBLOTE, CDALMOXARIFE, CDLOCALESTOQ;

          OPEN C_INSERE;
          FETCH NEXT FROM C_INSERE INTO @V_NRLANCESTQ, @V_NRLOTEESTQ, @V_NRSUBLOTE, @V_NRSEQUITEM, @V_CDALMOXARIFE,
                                        @V_CDLOCALESTOQ;

          WHILE (@@FETCH_STATUS = 0) BEGIN

             SELECT @V_VRLANCTOEST  = ISNULL(A.VRLANCTOEST,0),
                    @V_VRLANCTOBRUT = ISNULL(A.VRLANCTOBRUT,0),
                    @V_VRFATOCONV   = B.VRFATOCONV,
                    @V_NRLANCTONF   = D.NRLANCTONF,
                    @V_QTTOTLANCTO  = QTTOTLANCTO,
                    @V_VRTOTLANCTO  = A.VRTOTLANCTO,
                    @V_VRUNILANCTO  = A.VRUNILANCTO,
                    @V_CDFILIMOVI   = A.CDFILIMOVI,
                    @V_IDTPLANCTO   = D.IDTPLANCTO,
                    @V_CDFILIAL     = D.CDFILIAL,
                    @V_VRCUSTLOGLAN = CASE QTTOTLANCTO WHEN 0 THEN 0 ELSE (VRCUSTLOGLAN/QTTOTLANCTO) END,
                    @V_VRSEGULOGLAN = CASE QTTOTLANCTO WHEN 0 THEN 0 ELSE (VRSEGULOGLAN/QTTOTLANCTO) END
               FROM ITLANCTOEST A, PRODUTO B, PRODFILI C, LANCTOESTOQ D
              WHERE (A.CDFILIMOVI = @P_FILIAL)            AND
                    (A.NRLANCESTQ = @V_NRLANCESTQ) AND

                    (B.CDPRODUTO  = A.CDPRODUTO)         AND

                    (C.CDFILIAL   = A.CDFILIMOVI)        AND

                    (C.CDPRODUTO  = A.CDPRODMOVI)        AND

                    (D.CDFILIAL   = A.CDFILIAL)          AND
                    (D.NRLANCESTQ = A.NRLANCESTQ)        AND
                    (D.IDTPLANCTO IN ('0','2', 'E'))     AND
                    (A.NRSEQUITEM = @V_NRSEQUITEM);


             IF (@V_CDFILIAL IS NOT NULL) BEGIN
                SET @V_VRULTCMPLIQ  = 0;
                SET @V_VRULTCMPBRU  = 0;
                SET @V_VRULTCMPLM1  = 0;
                SET @V_VRULTCMPLM2  = 0;
                SET @V_VRULTCMPBM1  = 0;
                SET @V_VRULTCMPBM2  = 0;

                IF (@V_CDINDICEMF IS NOT NULL) BEGIN
                   SELECT @V_VRINDICE1 = MAX(VRINDICE)
                     FROM INDICE I, MOVINDICE M
                    WHERE I.CDTPINDICE = @V_CDTPINDICE AND
                          I.IDPERVALOR = @V_IDPERVALOR AND
                          I.CDINDICE   = @V_CDINDICEMF AND
                          M.CDTPINDICE = I.CDTPINDICE  AND
                          M.IDPERVALOR = I.IDPERVALOR  AND
                          M.CDINDICE   = I.CDINDICE    AND
                          CONVERT(VARCHAR,M.DTREFIND) = CONVERT(VARCHAR,@V_DTLANCMOVI);


                   IF (@V_VRINDICE1 = 0) BEGIN
                      SET @V_MSG1 = 'ndice Financeiro Parametrizado na Personalizao do Sistema,no Possui valor Cadastrado para a Data '+CONVERT(VARCHAR,@V_DTLANCMOVI);
                      RAISERROR(@V_MSG1,1,16);
                   END;
                END;

                IF (@V_CDINDICEMF2 IS NOT NULL) BEGIN
                   SELECT @V_VRINDICE2 = MAX(VRINDICE)
                     FROM INDICE I, MOVINDICE M
                    WHERE I.CDTPINDICE = @V_CDTPINDICE2 AND
                          I.IDPERVALOR = @V_IDPERVALOR2 AND
                          I.CDINDICE   = @V_CDINDICEMF2 AND
                          M.CDTPINDICE = I.CDTPINDICE  AND
                          M.IDPERVALOR = I.IDPERVALOR  AND
                          M.CDINDICE   = I.CDINDICE    AND
                          CONVERT(VARCHAR,M.DTREFIND) = CONVERT(VARCHAR,@V_DTLANCMOVI);
                   IF (@V_VRINDICE2 = 0) BEGIN
                      SET @V_MSG2 = 'ndice Financeiro Parametrizado na Personalizao do Sistema,no Possui valor Cadastrado para a Data '+CONVERT(VARCHAR,@V_DTLANCMOVI);
                      RAISERROR(@V_MSG2,1,16);
                   END;
                END;

                IF (@V_VRFATOCONV IS NULL) OR (@V_VRFATOCONV = 0) BEGIN
                   SET @V_FATOCONV = 1;
                END
                ELSE BEGIN
                   SET @V_FATOCONV = @V_VRFATOCONV;
                END;

                IF (@V_IDTPLANCTO <> '0') BEGIN
                   SET @V_VRULTCMPLIQ = @V_VRLANCTOEST;
                   SET @V_VRULTCMPBRU = @V_VRLANCTOBRUT;
                END
                ELSE BEGIN
                   SET @V_VRULTCMPLIQ    = ((@V_VRLANCTOEST/@V_QTTOTLANCTO)/@V_FATOCONV);
                   SET @V_VRULTCMPBRU    = ((@V_VRLANCTOBRUT/@V_QTTOTLANCTO)/@V_FATOCONV);
                END;
                IF (@V_CDINDICEMF IS NOT NULL) BEGIN
                   IF (@V_IDTPLANCTO <> '0') BEGIN
                       SET @V_VRULTCMPLM1  = @V_VRLANCTOEST  * @V_VRINDICE1;
                       SET @V_VRULTCMPBM1  = @V_VRLANCTOBRUT * @V_VRINDICE1;
                       SET @V_VRCUSTLCMPM1 = @V_VRCUSTLOGLAN * @V_VRINDICE1;
                       SET @V_VRSEGULCMPM1 = @V_VRSEGULOGLAN * @V_VRINDICE1;
                   END
                   ELSE BEGIN
                      SET @V_VRULTCMPLM1  = (((@V_VRLANCTOEST/@V_QTTOTLANCTO)/@V_FATOCONV))  * @V_VRINDICE1;
                      SET @V_VRULTCMPBM1  = (((@V_VRLANCTOBRUT/@V_QTTOTLANCTO)/@V_FATOCONV)) * @V_VRINDICE1;
                      SET @V_VRCUSTLCMPM1 = @V_VRCUSTLOGLAN * @V_VRINDICE1;
                      SET @V_VRSEGULCMPM1 = @V_VRSEGULOGLAN * @V_VRINDICE1;
                   END;
                END;
                IF (@V_CDINDICEMF2 IS NOT NULL) BEGIN
                   IF (@V_IDTPLANCTO <> '0') BEGIN
                      SET @V_VRULTCMPLM2  = @V_VRLANCTOEST * @V_VRINDICE2;
                      SET @V_VRULTCMPBM2  = @V_VRLANCTOBRUT * @V_VRINDICE2;
                      SET @V_VRCUSTLCMPM2 = @V_VRCUSTLOGLAN * @V_VRINDICE2;
                      SET @V_VRSEGULCMPM2 = @V_VRSEGULOGLAN * @V_VRINDICE2;
                   END
                   ELSE BEGIN
                      SET @V_VRULTCMPLM2  = (((@V_VRLANCTOEST/@V_QTTOTLANCTO)/@V_FATOCONV))  * @V_VRINDICE2;
                      SET @V_VRULTCMPBM2  = (((@V_VRLANCTOEST/@V_QTTOTLANCTO)/@V_FATOCONV))  * @V_VRINDICE2;
                      SET @V_VRCUSTLCMPM2 = @V_VRCUSTLOGLAN * @V_VRINDICE2;
                      SET @V_VRSEGULCMPM2 = @V_VRSEGULOGLAN * @V_VRINDICE2;
                   END;
                END;
                IF (ISNULL(@V_VRULTCMPLIQ ,0) <> 0) OR (ISNULL(@V_VRULTCMPBRU,0)  <> 0) OR (ISNULL(@V_VRULTCMPLM1,0) <> 0) OR (ISNULL(@V_VRULTCMPBM1,0) <> 0) OR
                   (ISNULL(@V_VRCUSTLCMPM1,0) <> 0) OR (ISNULL(@V_VRSEGULCMPM1,0) <> 0) OR (ISNULL(@V_VRULTCMPLM2,0) <> 0) OR (ISNULL(@V_VRULTCMPBM2,0) <> 0) OR
                   (ISNULL(@V_VRCUSTLCMPM2,0) <> 0) OR (ISNULL(@V_VRSEGULCMPM2,0) <> 0) BEGIN

                   INSERT INTO CUSTOCMPPROD
                      (CDFILIAL,     DTCUSTCMPPRO,   CDFILLANCEST,   NRLANCESTQ,   CDPRODUTO,
                       CDALMOXARIFE, CDLOCALESTOQ,   NRLOTEESTQ,     NRSUBLOTE,    VRLIQCMPPROD,
                       VRBRUCMPPROD, VRLIQCMPPRM1,   VRLIQCMPPRM2,   VRBRUCMPPRM1, VRBRUCMPPRM2,
                       VRCUSTLOGCMP, VRCUSTLCMPM1,   VRCUSTLCMPM2,   VRSEGULOGCMP, VRSEGULCMPM1,
                       VRSEGULCMPM2)
                   VALUES
                      (@V_CDFILIMOVI,   @V_DATA,         @V_CDFILIAL,     @V_NRLANCESTQ,   @V_CDPRODUTO,
                       @V_CDALMOXARIFE, @V_CDLOCALESTOQ, @V_NRLOTEESTQ,   @V_NRSUBLOTE,    @V_VRULTCMPLIQ,
                       @V_VRULTCMPBRU,  @V_VRULTCMPLM1,  @V_VRULTCMPLM2,  @V_VRULTCMPBM1,  @V_VRULTCMPBM2,
                       @V_VRCUSTLOGLAN, @V_VRCUSTLCMPM1, @V_VRCUSTLCMPM2, @V_VRSEGULOGLAN, @V_VRSEGULCMPM1,
                       @V_VRSEGULCMPM2);
                END;
             END;
             FETCH NEXT FROM C_INSERE INTO @V_NRLANCESTQ, @V_NRLOTEESTQ, @V_NRSUBLOTE, @V_NRSEQUITEM, @V_CDALMOXARIFE,
                                           @V_CDLOCALESTOQ;
          END;
          CLOSE C_INSERE;
          DEALLOCATE C_INSERE;
          SET @V_DATA = DATEADD(DD, 1, @V_DATA);
       END;
       FETCH NEXT FROM C_PRODUTO INTO @V_CDPRODUTO;
    END;
    CLOSE C_PRODUTO;
    DEALLOCATE C_PRODUTO;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_CUSTO_COMPRA','5.11.000';
GO
